FROM tensorflow/tensorflow:2.14.0-gpu

ENV NVIDIA_VISIBLE_DEVICES all
ENV NVIDIA_DRIVER_CAPABILITIES=all
ENV NVIDIA_REQUIRE_CUDA "cuda>=8.0"

# Install nobrainer through pip
RUN pip install nobrainer

# Copy in our files into /work
WORKDIR /work
COPY ./ /work/
RUN chmod a+x run.py

LABEL org.nrg.commands="[{\"name\": \"nobrainer\", \"label\": \"nobrainer\", \"description\": \"Runs nobrainer v1.0\", \"version\": \"1.0\", \"schema-version\": \"1.0\", \"image\": \"registry.gitlab.com/flywheel-io/clinical-solutions/xnat-cs-containers/nobrainer:1.0\", \"type\": \"docker\", \"command-line\": \"python run.py #VERBOSE# #OUTPUTFILE# #MODEL# #THRESHOLD# #LARGESTLABEL# #ROTATEPREDICT#\", \"override-entrypoint\": true, \"mounts\": [{\"name\": \"in\", \"writable\": false, \"path\": \"/input\"}, {\"name\": \"out\", \"writable\": true, \"path\": \"/output\"}], \"environment-variables\": {}, \"ports\": {}, \"inputs\": [{\"name\": \"model\", \"description\": \"Pre-trained model\", \"type\": \"select-one\", \"default-value\": \"brainy\", \"required\": true, \"replacement-key\": \"#MODEL#\", \"command-line-flag\": \"--model\", \"command-line-separator\": \" \", \"select-values\": [\"brainy\"]}, {\"name\": \"verbose\", \"description\": \"Switch on progress logs.\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#VERBOSE#\", \"true-value\": \"--verbose\", \"false-value\": \"\", \"select-values\": []}, {\"name\": \"largest_label\", \"description\": \"Zero out all values not connected to the largest contiguous label (not  including 0 values). This remove false positives in binary prediction.\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#LARGESTLABEL#\", \"true-value\": \"--largest-label\", \"false-value\": \"\", \"select-values\": []}, {\"name\": \"rotate_and_predict\", \"description\": \"Average the prediction with a prediction on a rotated (and subsequently un-rotated) volume. This can produce a better overall prediction.\", \"type\": \"boolean\", \"default-value\": \"false\", \"required\": false, \"replacement-key\": \"#ROTATEPREDICT#\", \"true-value\": \"--rotate-and-predict\", \"false-value\": \"\", \"select-values\": []}, {\"name\": \"output_file\", \"description\": \"Name of output brain mask.\", \"type\": \"string\", \"default-value\": \"\", \"required\": false, \"replacement-key\": \"#OUTPUTFILE#\", \"command-line-flag\": \"--output-file\", \"command-line-separator\": \" \", \"select-values\": []}, {\"name\": \"threshold\", \"description\": \"Threshold used to binarize model output. Only used in binary prediction and must be in (0, 1).\", \"type\": \"number\", \"default-value\": \"0.3\", \"required\": true, \"replacement-key\": \"#THRESHOLD#\", \"command-line-flag\": \"--threshold\", \"command-line-separator\": \" \", \"select-values\": []}], \"outputs\": [{\"name\": \"nobrainer\", \"description\": \"nobrainer\", \"required\": true, \"mount\": \"out\", \"glob\": \"\"}], \"xnat\": [{\"name\": \"nobrainer\", \"label\": \"nobrainer-v1.0\", \"description\": \"Run nobrainer v1.0\", \"contexts\": [\"xnat:imageScanData\"], \"external-inputs\": [{\"name\": \"scan\", \"description\": \"Input scan\", \"type\": \"Scan\", \"required\": true, \"provides-files-for-command-mount\": \"in\", \"load-children\": false}], \"derived-inputs\": [], \"output-handlers\": [{\"name\": \"nobrainer\", \"accepts-command-output\": \"nobrainer\", \"as-a-child-of\": \"scan\", \"type\": \"Resource\", \"label\": \"nobrainer\", \"tags\": []}]}], \"reserve-memory\": 1000, \"container-labels\": {}, \"generic-resources\": {}, \"ulimits\": {}, \"secrets\": []}]"